// 221_2.cpp:   .

#include "stdafx.h"

#include <string>  //  string  wstring
#include <conio.h>
#include <iostream> //  C++ 

using namespace System;

//     string  wstring 
using namespace std;  
using namespace Runtime::InteropServices;

// ====   s  os  string
void MarshalString ( String^ s, string& os )
{
	// -   managed- 
	//    ()    
	//  void     
	//   
	// (    const char*): 
	const char* chars = 
		(const char*)(Marshal::StringToHGlobalAnsi(s)).ToPointer();
	// os -      char:
	os = chars;

	//     , 
	//   :
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}

// ====   s  os  wstring
void MarshalString ( String^ s, wstring& os )
{
	// -   managed-
	//    ()    
	//  void      
	//   
	// (    const wchar_t*:
	const wchar_t* chars =
		(const wchar_t*)(Marshal::StringToHGlobalUni(s)).ToPointer(); 
	os = chars; //  , .   

	//     , 
	//   : 
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}

void main()
{
	string a = "test";
	wstring b = L"test2";  //""  ( 2   ) 
	String^ c = gcnew String("abcd");

	cout << a << endl; //  
	MarshalString(c, a);  //   

	c = "efgh";
	MarshalString(c, b); //   b

	cout << a << endl;  // 
	wcout << b << endl; // b
	
	_getch();
}
